Subject: devel-digest V2 #195
From: [email-masked] (devel-digest)
To: [email-masked]

devel-digest          Saturday, June 12 1999          Volume 02 : Number 195

In this issue:

    Re: floatlib.c
    Re: floatlib.c

See the end of this digest for information about devel-digest.

----------------------------------------------------------------------

Date: Fri, 11 Jun 1999 10:31:30 +0100
From: Philip Blundell <[email-masked]>
Subject: Re: floatlib.c

Scott Bambrough wrote:

> I'm not sure about that.  Much of the code in functions is normalization and
> IEEE exception checking.  If we could ensure all numbers are normalized we could
> get rid of that.  The exception checks would have to remain.  The only other
> improvements would be to use the ARMv4 instructions, but then this would lead to
> problems on ARMv3 and earlier machines.

Yeah.  The problem at the moment is that GCC doesn't favour the common case
(normalized operands and no exceptions) over the uncommon cases so the code path is
quite convoluted.  You can make things a bit better by strategic re-arrangement of
the code and use of `goto' but it's still not so great.

p.

- ---
This message processed by the Netwinder.Org news2mail gateway.

- --
This list is run automagically by Majordomo 1.94.4
Please send email questions to [email-masked]
To UNSUBSCRIBE: email [email-masked] with
"unsubscribe devel" as the body of your message.

------------------------------

Date: Fri, 11 Jun 1999 08:48:07 -0400
From: Scott Bambrough <[email-masked]>
Subject: Re: floatlib.c

This is a multi-part message in MIME format.
- --------------396C401C5A530D918F39A843
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: 7bit

Philip Blundell wrote:
> 
> Yeah.  The problem at the moment is that GCC doesn't favour the common case
> (normalized operands and no exceptions) over the uncommon cases so the code path is
> quite convoluted.  You can make things a bit better by strategic re-arrangement of
> the code and use of `goto' but it's still not so great.
> 

I'm not quite sure what you mean here.  As far as I have seen, GCC always
delivers normalized operands.  It cannot guarantee a calculated result, used as
an operand will be normalized so the routines always have to check.  As far as
IEEE exceptions go, I can't think of any thing GCC should concern itself with;
this is library/program issue.

There are probably faster ways to implement floating point and shortcuts we can
take.  IEEE floating point carries a significant amount of baggage.  However, it
was designed to portable, to guarantee a certain number of bits of accuracy, and
to give the same results across multiple platforms.  Most of the shortcuts I
have had proposed involved losing some of this baggage, and breaking the IEEE
conformity.  This is a bad thing IMHO.

Scott
- --------------396C401C5A530D918F39A843
Content-Type: text/x-vcard; charset=us-ascii; name="vcard.vcf"
Content-Transfer-Encoding: 7bit
Content-Description: Card for Scott Bambrough
Content-Disposition: attachment; filename="vcard.vcf"

begin:          vcard
fn:             Scott Bambrough
n:              Bambrough;Scott
org:            Rebel.com
adr:            150 Isabella St.;;;Ottawa;Ontario;K1S 1V7;Canada
email;internet: [email-masked]
title:          Software Engineer
tel;work:       (613) 788-6000 x6116
tel;fax:        (613) 230-8300
x-mozilla-cpt:  ;0
x-mozilla-html: FALSE
version:        2.1
end:            vcard

- --------------396C401C5A530D918F39A843--

- ---
This message processed by the Netwinder.Org news2mail gateway.

- --
This list is run automagically by Majordomo 1.94.4
Please send email questions to [email-masked]
To UNSUBSCRIBE: email [email-masked] with
"unsubscribe devel" as the body of your message.

------------------------------

End of devel-digest V2 #195
***************************

--
This list is run automagically by Majordomo 1.94.4
Please send email questions to [email-masked]
To UNSUBSCRIBE: email [email-masked] with
"unsubscribe devel-digest" as the body of your message.